#include <iostream>

using namespace std;

const int MaxN=100;
struct DataT{
    string date;
    double amount;
    double quantity;
};
typedef DataT DataArray[MaxN];


int main()
{
    cout << "p200416" << endl;

    /// declaration
    int N;
    DataArray data;

    bool exist;
    string when;
    double sum;
    int cnt;
    string days[MaxN];

    /// input

    bool error=false;
    string tmp;
    do {
        cout << "N=? :";
        cin >> tmp;
        N=atoi(tmp.c_str());
        error=((N<=0) || (MaxN<N));
        if (error) {
            cout << " ERROR! N must be between 1 and " << MaxN << "!" << endl;
        }
    } while (error);

    for (int i=0;i<N;i++) {
        cout << (i+1) << ". data:" << endl;

        cout << "  date=? :";
        cin >> data[i].date;
        //getline(cin,data[i].date);

        do {
            cout << "  amount=? :";
            cin >> tmp;
            data[i].amount=atof(tmp.c_str());
            error=(data[i].amount<=0);
            if (error) {
                cout << " ERROR! amount must be greater then 0!" << endl;
            }
        } while (error);

        do {
            cout << "  quantity=? :";
            cin >> tmp;
            data[i].quantity=atof(tmp.c_str());
            error=(data[i].quantity<=0);
            if (error) {
                cout << " ERROR! quantity must be greater then 0!" << endl;
            }
        } while (error);
    }

    /// implement the algorithms
    int i=0;
    while ((i<N) && (data[i].amount!=20000)) {
        ++i;
    }
    exist=(i<N);
    if (exist) {
        when=data[i].date;
    } else {
        when="never";
    }

    sum=0;
    for (int i=0;i<N;i++) {
        sum+=data[i].amount;
    }

    cnt=0;
    for (int i=0;i<N;i++) {
        if (data[i].quantity>40) {
            days[cnt]=data[i].date;
            cnt++;
        }
    }

    /// output

    if (exist) {
        cout << "We payed 20.000,- on " << when << endl;
    } else {
        cout << "We did not pay 20.000,-" << "(" << when << ")"<< endl;
    }

    cout << "We payed " << sum << "." << endl;

    cout << "We bought more then 40 liters gasoline " << cnt << " times." << endl;
    for (int i=0;i<cnt;i++) {
        cout << "  " << days[i] << endl;
    }

    return 0;
}
